/*
	BrwMon1.prg  -  See CHANGELOG and ToDo List at tha bottom of this file.
	Free, open source code to use with Harbour/miniGUI
	Sorry for my "no good" english, I'm learnig it too.
	For your text editor, I handle Tabs with 3 spaces.  <------------------------

	What if your program automatically shows secondary database info depending on
	record selected by end user at the primary database, but him (the user) click
	with the right button... this not jump to your ON CHANGE event code.
	--> The user could think that the info he is seeing is the correct one. <----
	Left click jumps correctly the ON CHANGE event
	Right click appears to no change the RECNO() pointer, even with SET BROWSESYNC ON,
   this seems to be the fact why ON CHANGE is not launched.

   REMEMBER: this is only a patch, a temporary workaround ! <-------------------
     Keep looking for news on miniGUI official (BROWSE)OnChange for right click behavior
     Anyway, miniGUI lets develop very powerful programs. Thanks, Mr. Roberto Lopez!
     (Also thanks to the Harbour & MinGW teams !)

	This is my set of functions (you can be an alfa tester)

		BRWMonitorBegin()
		BRWMonitorTimerPause()
		BRWMonitorTimerResume()

		BRWMonitorTimerRelease()
		BRWMonitor()

	The code is tiny, but is fully commented with sintax and every you need.

	-> This process uses a timer wich periodically compares de VALUE property
		of the browse object with its database RECNO() and jumps to a function
		you can write in your own code in order to handle it.

	-----------------------------------------------------------------------------
	Personal note:
		Maybe there is a command... and I don't know how to handle this behavior.
		If this is a stupid thing, please let me know (also your changes)
		ArturoGarciaVazquez@yahoo.com.mx      <-----------------------------------
		please, allways use "HMGForum - your text" in subject so I can filter eMails
		(I downloaded miniGUI 2.6.7 few days ago in order to learn windows programing,
		the last programs I wrote with Clipper Summer '87 and Turbo Pascal 5?)
		
*/

//==============================================================================
// you can include this routines in your main code with   #include "BrwMon1.prg"
//==============================================================================
#define cBRWMonitorTimerName "BRWMonitorTimerName"


/*------------------------------------------------------------------------------
	sintax: BRWMonitor( [ 0 ] )  --> returns previous value of a control public var
	If for debug purposes you want the BRWMonitor set of functions be ignored,
	that is, returnig inmediately with no executing its process at all, you can
	use  BRWMonitorTimerPause()  		// if timer is already running
	and  BRWMonitor( 0 ) 	// to nullify the action of BRWMonitor set of functions
	
	list of codes
		0		causes an inmediate return (with no process excuted on every BRWMonitor functions
		1		BRWMonitor functions do their job normally - dafault initial value
	other		unknow, is programer responsibility to not set other than valid values
*/
Function BRWMonitor( pnCodeToSet )
LOCAL nCodeToReturn

	IF .NOT. TYPE("nBRWPublicCode") == "N"
		PUBLIC nBRWPublicCode := 1 		// default first status code is:  1 (ON)
	ENDIF
	
	nCodeToReturn := nBRWPublicCode		// allways returns previous status

	IF PCOUNT() = 1
		nBRWPublicCode := pnCodeToSet		// optional, new code to set
	ENDIF

Return nCodeToReturn


/*------------------------------------------------------------------------------
	sintax: BRWMonitorBegin( <cWindowNameToUse>, <arrayBrowseObjects>, ;
										<cUserFunction>, <nIntervalMilliseconds> )  -> Nil
	Creates a timer object in <cWindowNameToUse> and starts the monitoring of databases
	<arrayBrowseObjects>
			is an array with the specifics of each browse object to be monitorizing
			in the following format:
				{
					{ <cWindowName1> , <cBrowseName1> , <cDatabaseAliasName1> }  ,  ;
					{ <cWindowName2> , <cBrowseName2> , <cDatabaseAliasName2> }  ,  ;
					...
					{ <cWindowNameN> , <cBrowseNameN> , <cDatabaseAliasNameN> }     ;
				}
	<cUserFunction> 
			is an user defined function specified surrounded with quotes
			and without parenthesis wich be called internally (with 2 parameters, see
			below) every time the BRW monitor detects a diference between
			<cWindowName>.<cBrowseName>.VALUE   and   its respective   RECNO()
			caused when an end user selects a record in the main database with
			the right button of the mouse (which not shoot the ON CHANGE event).
			Inside this user defined function you are able to update the visuals
			of a secondary database.
			Your user defined function *must* receive 2 parameters of type array
			<alBrowseObjectList>  and  <arrayBrowseObjects>
			the first array is a list of logicals .T./.F. indicating with .T.
			If a browse pointer (VALUE property) has been changed and differs of its
			respective RECNO()
			The second array parameter received for your user defined function is
			the same array you provided with your Browse Objects List
			IMPORTANT.
					To avoid problems with recursive calls, BRWMonitorTimerPause()
					is executed just before your user defined function is called.
					Your user defined function *must* return a .T. or .F.,
					but only when .T. is returned a call to BRWMonitorTimerResume()
					is made.
	<nIntervalMilliseconds>
			Is the period of time to use as INTERVAL in the timer that monitorizes
			your databases. Maybe 1/4 or 1/2 second seems to be Ok, but this is on you.
*/
Function BRWMonitorBegin( pcWindowNameToUse, pacBrwObjectsToMonitor, pcProcedureName, pnInterval )
LOCAL nInterval := IIF( pnInterval < 100, 100, INT(pnInterval) )  // avoid hang

	IF BRWMonitor() = 0
		Return Nil
	ENDIF
	
	DEFINE TIMER &cBRWMonitorTimerName OF &pcWindowNameToUse ;
		INTERVAL nInterval ;
		ACTION BRWMonitorTimerTask( pcWindowNameToUse, pacBrwObjectsToMonitor, pcProcedureName )

Return Nil


/*------------------------------------------------------------------------------
	sintax: BRWMonitorTimerPause( <cWindowName> )  -> Nil
	Pauses the monitorizing process. (disables the timer)
	<cWindowName>
			is the same  cWindowNameToUse  you specified in BRWMonitorBegin()

	UNFORGETTABLE!  "BRWMonitoring" is a LIVE process, so keep that in mind
	when you plain to APPEND BLANK, REINDEX or whatever action that moves your
	record pointers.
	ALWAYS, prior to do that, make a call to BRWMonitorTimerPause()
	and you can only make a call to BRWMonitorTimerResume() when you know
	for sure that inmediately you will return to the main event loop so
	your User Defined Function can properly handle any pointer updates required.
*/
Function BRWMonitorTimerPause( pcWindowNameToUse )
	IF BRWMonitor() = 0
		Return Nil
	ENDIF
	
	SetProperty( pcWindowNameToUse, cBRWMonitorTimerName, "ENABLED", .F. )
Return Nil


/*------------------------------------------------------------------------------
	sintax: BRWMonitorTimerResume( <cWindowName> )  -> Nil
	Resumes the monitorizing process. (reenables the timer)
	<cWindowName>
			is the same  cWindowNameToUse  you specified in BRWMonitorBegin()
	
	Please, see comments for BRWMonitorTimerPause()
*/
Function BRWMonitorTimerResume( pcWindowNameToUse )
	IF BRWMonitor() = 0
		Return Nil
	ENDIF
	
	SetProperty( pcWindowNameToUse, cBRWMonitorTimerName, "ENABLED", .T. )
Return Nil


/*------------------------------------------------------------------------------
	sintax: BRWMonitorTimerRelease( <cWindowName> )  -> Nil
	Stops and destroys the monitorizing process. (release the timer)
	<cWindowName>
			is the same  cWindowNameToUse  you specified in BRWMonitorBegin()
	
	It is not necesary to call this function when the attached window <cWindowName>
	is released in your main program.
*/
Function BRWMonitorTimerRelease( pcWindowNameToUse )
	IF BRWMonitor() = 0
		Return Nil
	ENDIF
	
	DoMethod( pcWindowNameToUse, cBRWMonitorTimerName, "RELEASE" )
Return Nil


/*------------------------------------------------------------------------------
	internal monitorizing task, programer not need to call this function
	here is where the party takes place...
*/
Function BRWMonitorTimerTask( pcWindowNameToUse, pacBrwObjectsToMonitor, pcProcedureName )
LOCAL n, ;
		nCurrentValueFromBrwObject, ;
		nCurrentValueFromRecno, ;
		cRecnoExpression, ;
		lUDFNeedToBeCalled, ;
		lBrwWantToConinue, ;
		cCallUDFwithStatusList
PRIVATE alBRWList := {}		// seems to be necesary PRIVATE to use with & macro
PRIVATE acBrwObjectsToMonitor := pacBrwObjectsToMonitor

	IF BRWMonitor() = 0
		Return Nil
	ENDIF
	
	BRWMonitorTimerPause( pcWindowNameToUse )	// avoid recursive timer calls
	
	// let's compare "Form_name"."Browse_name".VALUE  !=  "dbfAliasName"->( RECNO() )
	// and stores each result in alBRWList array
	lUDFNeedToBeCalled := .F.
	FOR n := 1 TO len(pacBrwObjectsToMonitor)
		nCurrentValueFromBrwObject := getproperty( pacBrwObjectsToMonitor[n,1], pacBrwObjectsToMonitor[n,2], "VALUE" )
		cRecnoExpression := pacBrwObjectsToMonitor[n,3] + "->( RECNO() )"
		nCurrentValueFromRecno := &cRecnoExpression
		aAdd( alBRWList, ( nCurrentValueFromBrwObject != nCurrentValueFromRecno ) )
		IF alBRWList[n] = .T. 	// pointers changed ? (most probably by right click)
			lUDFNeedToBeCalled := .T.
		ENDIF
	NEXT n

	lBrwWantToConinue := .T.
	IF lUDFNeedToBeCalled	// let us call user defined function
		// User defined function *MUST* return .T./.F. if want (or not) resume monitoring
		cCallUDFwithStatusList := pcProcedureName + "( alBRWList, acBrwObjectsToMonitor )"
		lBrwWantToConinue := &cCallUDFwithStatusList
	ENDIF
	
	IF lBrwWantToConinue
		BRWMonitorTimerResume( pcWindowNameToUse )	// resume timer "monitoring"
	ENDIF
	
Return Nil


/***  ToDo LIST  *************************************************

****  CHANGELOG  ***************************************************************
2009.
2009.01.24 - fix: BRWMonitor() now correctly returns "previous status"
             fix: BRWMonitorBegin() now never accepts an interval less than 100 ms
             fix: BRWMonitorTimerRelease() now it does what it is intended to do
             chg: changes on documentation and sample Browse2NEW.prg
             rem: discarded the creation of BRWMonitorSetNewInterval()
2009.01.23 - first alfa released to be tested with Harbour/miniGUI v.2.6.7
             I just coded this routines yesterday
********************************************************************************/
